package ke;

import java.util.*;

/**
 * MSc Knowledge Engineering 2004-2005 (Semester 2)
 * School of Informatics, The University of Edinburgh
 * Second Practical Assignment
 * Author: Michael Rovatsos
 */


//class used to implement agents and their behaviour
//each agent runs in its own thread of control, maintains 
//a local set of learning samples and a local learning hypothesis
public class Agent implements Runnable {


    private Hypothesis hypothesis; //the current learning hypothesis
    private String name;           //the agent's name
    private SystemManager manager; //the manager's reference
    private int[][] samples;       //the agent's learning samples

    //setting this to true 
    private boolean terminated;
    
    //constructor in which agent name and system manager reference are
    //passed; this also automatically starts the agent's own thread of
    //control
    public Agent(String n, SystemManager m) {
	name = n; 
	manager = m;
	//read samples from file
	//samples = new int[...][...];

	//generate some initial hypothesis
	int[] h = {1,-1,0,0,1};
	hypothesis  = new Hypothesis(h);

	//this starts the agent's thread of control and calls the 
	//"run()" procedure
	terminated = false;
	(new Thread(this)).start();	
    }

 
    //main thread processing cycle
    //NOT TO BE MODIFIED
    public final void run() {
	while(!terminated) {
	    try{
		Thread.sleep(10);
	    }
	    catch(InterruptedException e) {
		e.printStackTrace();
	    }
	    Message newMessage = reason();
	    if(newMessage!=null)
		manager.post(newMessage);	    
	}	
	System.out.println("Agent "+name+" shutting down");
    }
    

    //main reasoning cycle, called once each time the agent
    //loops through run(); the returned value of this should always be
    //a message, or null should be returned if no
    //message is to be generated; if the result is non-null, it will 
    //automatically be posted to the blackboard
    public final Message reason() {
	//check blackboard contents
	//consider new hypotheses: 
	// - how they perform on your own samples compared to own
	//   hypothesis
	// - generalise between new ones and your own and 
	//   compare performance on own samples
	// - choose to withdraw own hypothesis (and introduce new one,
	//   or support someone else's) or maintain it
	// - send the respective message to the system manager
	return new Message(name,"wishEveryone","good luck with the assignment");
    }

    //sets the termination flag to true so that run() will terminate
    //NOT TO BE MODIFIED
    public final void terminate() {
	terminated = true;
    }
}
 